routes/web.php
<?php

use App\Http\Controllers\AssignTaskController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\GrantNewTokenController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\RequestTokenController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\TrashedClientController;
use App\Http\Controllers\TrashedProjectController;
use App\Http\Controllers\TrashedTaskController;
use App\Http\Controllers\TrashedUserController;
use App\Http\Controllers\UnassignTaskController;
use App\Http\Controllers\UpdatePasswordController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;
use Symfony\Component\HttpKernel\Profiler\Profile;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes(['register' => false]);

Route::redirect('/', 'login');

Route::middleware(['guest'])->group(function() {
    Route::controller(ChangePasswordController::class)->prefix('/change-password')->group(function () {
        Route::get('/{token}', 'create')->name('change-password.create');
        Route::post('/', 'store')->name('change-password.store');
    });

    Route::controller(RequestTokenController::class)->prefix('/request-token')->group(function () {
        Route::get('/{token}', 'create')->name('request-token.create');
        Route::post('/', 'store')->name('request-token.store');
    });
});


Route::middleware(['auth', 'password_not_changed'])->group(function (){
    Route::get('/dashboard', DashboardController::class)->name('dashboard');
    Route::post('/new_password', [UpdatePasswordController::class, 'store'])->name('new-password.store');

    Route::controller(ProfileController::class)->prefix('/profiles/{user}')->group(function (){
        Route::get('/', 'show')->name('profiles.show');
        Route::get('/edit', 'edit')->name('profiles.edit');
        Route::put('/', 'update')->name('profiles.update');
    });

    Route::resource('users', UserController::class);
    Route::patch('/users/{user}/restore', [UserController::class, 'restore'])->withTrashed()->name('users.restore');
    Route::post('users/{user}/token', GrantNewTokenController::class)->name('users.new-token');

    Route::resource('clients', ClientController::class);
    Route::patch('/clients/{client}/restore', [ClientController::class, 'restore'])->withTrashed()->name('clients.restore');
    Route::patch('/clients/{client}/forcedelete', [ClientController::class, 'forceDelete'])->withTrashed()->name('clients.force-delete');
    
    Route::resource('projects', ProjectController::class);
    Route::patch('/projects/{project}/restore', [ProjectController::class, 'restore'])->withTrashed()->name('projects.restore');
    Route::patch('/projects/{project}/forcedelete', [ProjectController::class, 'forceDelete'])->withTrashed()->name('projects.force-delete');

    Route::resource('tasks', TaskController::class);
    Route::patch('/tasks/{task}/restore', [TaskController::class, 'restore'])->withTrashed()->name('tasks.restore');
    Route::patch('/tasks/{task}/forcedelete', [TaskController::class, 'forceDelete'])->withTrashed()->name('tasks.force-delete');
    Route::patch('/tasks/{task}/unassign', UnassignTaskController::class)->name('tasks.unassign');
    Route::patch('/tasks/{task}/assign', AssignTaskController::class)->name('tasks.self-assign');

    Route::get('/trashed/projects', TrashedProjectController::class)->name('projects.trashed');
    Route::get('/trashed/clients', TrashedClientController::class)->name('clients.trashed');
    Route::get('/trashed/tasks', TrashedTaskController::class)->name('tasks.trashed');
    Route::get('/trashed/users', TrashedUserController::class)->name('users.trashed');
});

app/Models/Task.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;
use Spatie\Activitylog\LogOptions;
use Spatie\Activitylog\Traits\LogsActivity;

class Task extends Model
{
    use HasFactory, SoftDeletes, LogsActivity;

    protected $fillable = ['name', 'description', 'project_id', 'user_id', 'status_id'];

    protected $hidden = [
        'deleted_at',
   ];

    public static function boot()
    {
        parent::boot();

        static::deleting(function (Task $task) {
            $task->status_id = 4; //Closed
            $task->save();
        });
    }

    public function scopeFilter($query, array $filters)
    {
        $query->when($filters['status'] ?? false, function ($query, $status) {
            return $query->whereHas('status', function ($query) use ($status) {
                $query->where('slug', $status);
            })->get();
        });
    }

    public function project(): BelongsTo
    {
        return $this->belongsTo(Project::class)->withTrashed();
    }

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    public function status(): BelongsTo
    {
        return $this->belongsTo(Status::class);
    }

    public function getActivitylogOptions(): LogOptions
    {
        return LogOptions::defaults()
            ->logOnly(['name', 'description', 'user.name', 'project.title', 'status.name'])
            ->logOnlyDirty();
    }
}

app/Http/Controllers/Api/TaskController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Requests\TaskRequest;
use App\Http\Resources\TaskResource;
use App\Models\Task;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class TaskController extends Controller
{
    public function __construct()
    {
        $this->middleware(['permission:create_task'])->only('store');
        $this->middleware(['permission:edit_task'])->only('update');
        $this->middleware(['permission:delete_task'])->only('destroy');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $tasks = Task::with('status', 'project', 'user')->paginate(10);

        return TaskResource::collection($tasks);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(TaskRequest $request)
    {
        $task = Task::make($request->validated());

        if(!$task->status_id) {
            $task->status_id = 1;
        }

        $task->save();

        // status: 201
        return (new TaskResource($task))->response(Response::HTTP_CREATED);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Task  $task
     * @return \Illuminate\Http\Response
     */
    public function show(Task $task)
    {
        $task->load('user', 'project', 'status');

        return new TaskResource($task);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Task  $task
     * @return \Illuminate\Http\Response
     */
    public function update(TaskRequest $request, Task $task)
    {
        $task->update($request->validated());

        // status: 200
        return (new TaskResource($task))->response(Response::HTTP_OK);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Task  $task
     * @return \Illuminate\Http\Response
     */
    public function destroy(Task $task)
    {
        $task->delete($task);

        // status: 204
        return response([], Response::HTTP_NO_CONTENT);
    }
}

app/Http/Controllers/TaskController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\TaskRequest;
use App\Mail\TaskAssignedMail;
use App\Models\Task;
use App\models\Project;
use App\Models\Status;
use App\Models\User;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use Illuminate\View\View;

class TaskController extends Controller
{
    public function __construct()
    {
        $this->authorizeResource(Task::class, 'task');
    }

    /**
     * Display a listing of the resource.
     *
     * @return View
     */
    public function index(): View
    {
        $builder = Task::query();

        if ($search = request()->get('search')) {
            $builder->where('id', $search)
                ->orwhere('name', 'LIKE', '%'.$search.'%');
        }

        $tasks = $builder->latest()
            ->filter(request()->only('status'))
            ->with(['project', 'user', 'status'])
            ->orderBy('updated_at', 'desc')
            ->paginate(10);

        return view('tasks.index', compact('tasks', 'search'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create(): View
    {
        $projects = Project::activeProjects();
        $users = User::all('id', 'name');

        return view('tasks.create', compact(['projects', 'users']));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param TaskRequest $request
     * @return RedirectResponse
     */
    public function store(TaskRequest $request): RedirectResponse
    {
        $task = Task::create($request->validated());

        if($request->user_id && Auth::id() != $request->user_id) {
            $user = User::find($request->user_id);

            Mail::to($user)->queue(new TaskAssignedMail($task));
        }

        return redirect()->route('tasks.index')
            ->with('success', 'The task has been created.');
    }

    /**
     * Display the specified resource.
     *
     * @param Task $task
     * @return View
     */
    public function show(Task $task): View
    {
        return view('tasks.show', compact('task'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Task $task
     * @return View
     */
    public function edit(Task $task): View
    {
        $projects = Project::activeProjects();
        $users = User::all('id', 'name');
        $states = Status::all();

        return view('tasks.edit', compact(['task', 'projects', 'users', 'states']));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param TaskRequest $request
     * @param Task $task
     * @return RedirectResponse
     */
    public function update(TaskRequest $request, Task $task): RedirectResponse
    {
        $task->update($request->validated());

        if (!empty($request->user_id) && $request->user_id != Auth::id()) {
            $user = User::find($request->user_id);

            Mail::to($user)->queue(new TaskAssignedMail($task));
        }

        return redirect()->route('tasks.show', $task)
            ->with('success', 'The task has been updated.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Task $task
     * @return RedirectResponse
     */
    public function destroy(Task $task): RedirectResponse
    {
        $task->delete();

        return redirect()->route('tasks.index')
            ->with('success', 'The task has been deleted.');
    }

    /**
     * @param Task $task
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function restore(Task $task): RedirectResponse
    {
        $this->authorize('restore', $task);

        if ($task->project->trashed()) {
            return redirect()->route('tasks.trashed')->with('danger', 'Could not restore the task. The project has been deleted. To restore this task you need to restore the project first.');
        }

        $task->restore();

        return redirect()->route('tasks.trashed')
            ->with('success', 'The task has been restored!');
    }

    /**
     * @param Task $task
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function forceDelete(Task $task): RedirectResponse
    {
        $this->authorize('forceDelete', $task);

        $task->forceDelete();

        return redirect()->route('tasks.trashed')
            ->with('success', 'The task has been permanently deleted.');
    }
}

resources/views/tasks/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h1 class="card-title text-capitalize">New Task</h1>
                    </div>
                    <div class="card-body">
                        <x-errors :errors="$errors" />

                        <form action="{{ route('tasks.store') }}" method="POST">
                            @csrf

                            <div class="form-group">
                                <label class="form-label" for="name">Name</label>
                                <input 
                                    type="text" 
                                    id="name" 
                                    name="name"
                                    class="form-control @error('name') is-invalid @enderror" 
                                    value="{{ old('name') }}"
                                    required>
                            </div>

                            <div class="row mt-2">
                                <div class="col">
                                    <div class="form-group">
                                        <label class="form-label" for="project_id">Assigned project</label>
                                        <select 
                                            id="project_id" 
                                            name="project_id"
                                            class="form-select @error('project_id') is-invalid @enderror" 
                                            required>
                                            <option value="">Select a project...</option>
                                            @foreach ($projects as $project)
                                                <option value="{{ $project->id }}" {{ old('project_id') == $project->id ? 'selected' : '' }}>
                                                    {{ $project->title }}
                                                </option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>

                                <div class="col">
                                    <div class="form-group">
                                        <label class="form-label" for="user_id">Assign to user</label>
                                        <select 
                                            id="user_id" 
                                            name="user_id"
                                            class="form-select @error('user_id') is-invalid @enderror">
                                            <option value="" selected>Select a user...</option>
                                            @foreach ($users as $user)
                                                <option value="{{ $user->id }}" {{ old('user_id') == $user->id ? 'selected' : '' }}>
                                                    {{ $user->name }}
                                                </option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="form-group mt-2">
                                <label class="form-label" for="description">Description</label>
                                <textarea 
                                    id="description" 
                                    name="description" 
                                    class="form-control @error('description') is-invalid @enderror" 
                                    cols="30"
                                    rows="8">{{ old('description') }}</textarea>
                            </div>

                            <div class="form-group mt-3">
                                <div class="d-flex justify-content-end">
                                    <a href="{{ route('tasks.index') }}" class="btn btn-outline-info mx-2">Cancel</a>
                                    <input type="submit" class="btn btn-success fw-semibold text-white text-capitalize" value="create task">
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/tasks/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">

                <div class="mb-2">
                    <a href="{{ route('tasks.show', $task) }}" class="btn btn-ghost-info">&#xab; Return to task page</a>
                </div>

                <div class="card">
                    <div class="card-header">
                        <h1 class="card-title">{{ $task->name }}</h1>
                    </div>

                    <div class="card-body">
                        <x-errors :errors="$errors" />

                        <form action="{{ route('tasks.update', $task) }}" method="POST">
                            @csrf
                            @method('PUT')

                            <div class="form-group">
                                <label class="form-label" for="name">Name</label>
                                <input 
                                    type="text" 
                                    id="name" 
                                    name="name" 
                                    class="form-control @error('name') is-invalid @enderror" 
                                    value="{{ old('name', $task->name) }}"
                                    required
                                >
                            </div>

                            <div class="row mt-2">
                                <div class="col">
                                    <div class="form-group">
                                        <label class="form-label" for="project_id">Assigned project</label>
                                        <select
                                            id="project_id"
                                            name="project_id"
                                            class="form-select @error('project_id') is-invalid @enderror"
                                            required>
    
                                            @foreach ($projects as $project)
                                                <option value="{{ $project->id }}" {{ old('project_id', $task->project_id) == $project->id ? 'selected' : '' }}>
                                                    {{ $project->title }}
                                                </option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="col">
                                    <div class="form-group">
                                        <label class="form-label" for="user_id">Assigned to user</label>
                                        <select
                                            id="user_id"
                                            name="user_id"
                                            class="form-select @error('user_id') is-invalid @enderror">
                                                <option value="" selected>Select a user...</option>
                                                @foreach ($users as $user)
                                                    <option value="{{ $user->id }}" {{ old('user_id', $task->user_id) == $user->id ? 'selected' : '' }}>
                                                        {{ $user->name }}
                                                    </option>
                                                @endforeach
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="row mt-2">
                                <div class="form-group col-md-6">
                                    <label class="form-label" for="status_id">Status</label>
                                    <select 
                                        id="status_id" 
                                        name="status_id" 
                                        class="form-select @error('status_id') is-invalid @enderror" 
                                        required>
                                        @foreach ($states as $state)
                                            <option value="{{ $state->id }}" {{ old('status_id', $task->status_id) == $state->id ? 'selected' : '' }}>
                                                {{ $state->name }}
                                            </option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>

                            <div class="form-group mt-2">
                                <label class="form-label" for="description">Description</label>
                                <textarea
                                    id="description"
                                    name="description"
                                    class="form-control @error('description') is-invalid @enderror"
                                    cols="30"
                                    rows="8"
                                >{{ old('description', $task->description ) }}
                                </textarea>
                            </div>
                            
                            <div class="form-group mt-2">
                                <div class="d-flex justify-content-end">
                                    <a href="{{ route('tasks.show', $task) }}" class="btn btn-outline-info me-2 text-capitalize">Cancel</a>
                                    <input type="submit" class="btn btn-success text-white fw-semibold text-capitalize" value="submit">
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

    </div>



{{-- <div class="container">

            <div class="card">

                <div class="card-body">
                    <x-errors :errors="$errors"/>


                        

                        <div class="row mt-2">
                            

                            
                        </div>

                        <div class="row mt-2">
                            
                        </div>

                        

                        
                    </form>
                </div>
            </div>
        </div>
    </div>
</div> --}}
@endsection

resources/views/tasks/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <x-flash-success :message="session('success')" />

                <div class="card">
                    <div class="card-header">
                        <div class="row align-items-center mb-1">
                            <div class="col-md-4">
                                <h1 class="card-title ms-2">Tasks</h1>
                            </div>

                            <div class="col-md-4">
                                <x-search :action="route('tasks.index')" :search="$search" placeholder="Search for a task by name or id"/>
                            </div>

                            <div class="col-md-4">
                                <div class="d-flex justify-content-end me-2">
                                    @can('create_task')
                                        <a href="{{ route('tasks.create') }}" class="btn btn-success text-white fw-semibold rounded me-2 text-capitalize">
                                            New Task
                                        </a>
                                    @endcan
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="card-body">
                        <div class="mb-2 ms-2">
                            <x-status-dropdown route="tasks.index" />

                            @if (!$tasks->count())
                                <p>No tasks yet.</p>
                            @else
                                <table class="table table-responsive-sm table-striped table-hover">
                                    <thead>
                                        <tr>
                                            <th>Name</th>
                                            <th>Project</th>
                                            <th>Assigned to</th>
                                            <th>status</th>
                                            <th>Last updated</th>
                                            @if (auth()->user()->can('edit_task') || auth()->user()->can('delete_task'))
                                                <th>Actions</th>
                                            @endif
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($tasks as $task)
                                            <tr class="align-items-center">
                                                <x-table-link route="tasks.show" :param="$task" :routeName="$task->name" />
                                                <x-table-link route="projects.show" :param="$task->project" :routeName="$task->project->title" />
                                                <td>{{ $task->user ? $task->user->name : 'Not assigned' }}</td>
                                                <td>{{ $task->status->name }}</td>
                                                <td><small>{{ $task->updated_at->diffForHumans() }}</small></td>

                                                <td class="d-flex align-items-center">
                                                    @can('edit_task')
                                                        <a class="btn btn-sm btn-info fw-semibold text-capitalize" href="{{ route('tasks.edit', $task) }}">
                                                            Edit
                                                        </a>
                                                    @endcan

                                                    @can('delete_task')
                                                        <form action="{{ route('tasks.destroy', $task) }}" method="POST" onsubmit="return confirm('Are you sure?');" style="display: inline-block;">
                                                            @csrf
                                                            @method('DELETE')
                                                            <input type="submit" class="btn btn-sm btn-danger text-white fw-semibold ms-2 text-capitalize" value="delete">
                                                        </form>
                                                    @endcan
                                                </td>
                                            </tr>
                                        @endforeach
                                    </tbody>
                                </table>

                                <div class="d-flex justify-content-between align-items-center clearfix">
                                    <div class="pl-2">
                                        <span class="fw-semibold">
                                            {{ $tasks->count() }} out of {{ $tasks->total() }} tasks
                                        </span>
                                    </div>
                                    <div class="justify-content-start">
                                        {{ $tasks->links() }}
                                    </div>
                                </div>
                            @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection